// Regulated Power Supply with volt and current read
#include <Wire.h>
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x27, 16, 2); //Check your library for specific LCD
//code both here and in setup.
float low_side_res = A0;
float volt_two;
float volt_three;
float volt_disp;
float low_side_res_2 = A1;
float hi_side_res = A2;
float volt_drop_1;
float amp;
float amp_3;
float amp_4;
float amp_disp;
void setup() {
  lcd.init();
  lcd.backlight();
}
void loop() {
  volt_two = analogRead(low_side_res);
  volt_three = (volt_two * 5) / 1024.0;
  volt_disp = volt_three * (10000 + 6800) / 6800; //Actual voltage reading
  amp_3 = analogRead(low_side_res_2);
  amp_4 = analogRead(hi_side_res);
  amp = amp_3 - amp_4;
  amp_disp = amp * 5 / 1024 * (10 + 6.8) / 6.8 / 1.22 * .9; //Calculation of amperage I=V/R
  //*0.9 = adjustment for random error in ref voltage in pro mini
  lcd.setCursor(1, 0);
  lcd.print("Volt ");
  lcd.setCursor(12, 0);
  lcd.print(volt_disp);
  lcd.setCursor(1, 1);
  lcd.print("mA ");
  lcd.setCursor(11, 1);
  lcd.print(amp_disp * 1000, 2);
}
