/* Deluxe Garage Sentry: goes with the shield PCB
*/
int ledPin = 8;
int ledPin1 = 7;
int ledPin2 = 10;
int ledPin3 = 9;
int count;
int analogPin = A0;
int val;
int y;
void setup() {
  //Initialize serial communication:
  Serial.begin(9600);
  pinMode(ledPin, OUTPUT);
  pinMode(ledPin1, OUTPUT);
  pinMode(ledPin2, OUTPUT);
  pinMode(ledPin3, OUTPUT);
  pinMode(analogPin, INPUT);
}
void loop() {
  val = analogRead(analogPin);
  long duration, inches, cm;
  pinMode(12, OUTPUT);
  digitalWrite(12, LOW);
  delayMicroseconds(2);
  digitalWrite(12, HIGH);
  delayMicroseconds(5);
  digitalWrite(12, LOW);
  pinMode(11, INPUT); //Attached to ECHO
  duration = pulseIn(11, HIGH);
  //Convert the time into a distance
  inches = microsecondsToInches(duration);
  cm = microsecondsToCentimeters(duration);
  val = map(val, 0, 1023, 0, 100);
  //Map the value of the potentiometer to 0 to 100
  if (inches == 0)
    digitalWrite(ledPin, LOW);
  if (count == 0 && inches > 0 && inches < val + 15)
    digitalWrite(ledPin2, HIGH);
  else digitalWrite(ledPin2, LOW);
  if (count == 0 && inches > 0 && inches < val + 7.5)
    digitalWrite(ledPin3, HIGH);
  else digitalWrite(ledPin3, LOW);
  if (count == 0 && inches > 0 && inches < val) {
    for (y = 0; y < 200; y++) { //Repeating blink sequence
      digitalWrite(ledPin, HIGH);
      digitalWrite(ledPin1, LOW);
      delay(100);
      digitalWrite(ledPin, LOW);
      digitalWrite(ledPin1, HIGH);
      delay(100);
    }
    count = count + 1; //Turn off instruction
  }
  digitalWrite(ledPin1, LOW);
  if (inches > 10) { //Reset if inches > 10
    delay(1000);
    count = 0;
  }
  Serial.print(inches);
  Serial.print(" inches ");
  Serial.print(count);
  Serial.print(" count ");
  Serial.println();
  Serial.print(" val ");
  Serial.println(val);
  delay(100);
}
long microsecondsToInches(long microseconds) {
  return microseconds / 74 / 2;
}
long microsecondsToCentimeters(long microseconds) {
  return microseconds / 29 / 2;
}
